Doomsday Engine - Feature #1655
Feature # 4 (In Progress): Ul improvements
Offscreen Ul composition

2013-11-05 08:11 - skyjake

Status: Closed Start date: 2013-11-05
Priority: Normal % Done: 100%
Assignee: skyjake

Category: Enhancement

Target version: 1.13

Description

Doomsday's Ul framework needs to have the ability to flatten a widget tree into an offscreen buffer (such as a GL texture) and then
use that offscreen buffer for further drawing operations.

This is useful for instance for applying shader effects or a custom 2D/3D projection to the UI.

Related issues:
Related to Feature #1636: Support for Oculus Rift Closed 2013-10-23

History

#1 - 2013-11-05 08:12 - skyjake
- % Done changed from 0 to 80

#2 - 2013-11-05 08:13 - skyjake

Currently implemented in the "oculus-rift" branch. The remaining missing detail is appropriate alpha blending for the flattened graphics.

#3 - 2013-11-05 08:13 - skyjake

- Target version set to 1.13

#4 - 2013-11-05 10:57 - skyjake

- Status changed from New to In Progress

#5 - 2013-11-11 10:39 - skyjake

- Status changed from In Progress to Closed

- % Done changed from 80 to 100

Marking this as completed: CompositorWidget can be used as the parent anywhere in the widget tree to create a composite of that branch.

The assumption currently is that the offscreen target is used to draw a transparent Ul layer, so the resulting texture is drawn back to the normal target
using premultiplied alpha blending.
